//{$WARNINGS OFF}
//=============================================================================
//  ADODB.StreamCharsetvpeBŎgp\CharsetXg
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2008N1213 `
//  2014N0415
//    EWindows 7 U64(SP1) + Delphi XE ProœmF
//    EWindows 7 U64(SP1) + Delphi XE ProœmF
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, Registry;

type
  TForm1 = class(TForm)
    Panel2: TPanel;
    Button1: TButton;
    ListBox1: TListBox;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses MultiLanguage_TLB;

{$R *.dfm}

//=============================================================================
//  ADODB.StreamCharsetvpeBŎgp\CharsetXg
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  Registry      : TRegistry;
  RegKey        : String;
  slCharsetList : TStringList;
begin
  slCharsetList := TStringList.Create;
  slCharsetList.Clear;
  slCharsetList.Sorted := True;

  //WXg當R[h̏擾ăXgɊi[
  Registry := TRegistry.Create(KEY_READ);
  try
    Registry.RootKey := HKEY_CLASSES_ROOT;

    RegKey := '\mime\database\Charset\';
    Registry.OpenKey(RegKey, False);
    Registry.GetKeyNames(slCharsetList);
    Registry.CloseKey;
    Listbox1.Items.Assign(slCharsetList);
  finally
     Registry.Free;
     FreeAndNil(slCharsetList);
  end;
end;

//=============================================================================
//  Listbox1őICharsset̃WXg̏擾ĕ\
//  MLang̋@\gpČꖼ擾
//
//  ȉ̃L[邪C`ĂȂ̂
//  CodePage
//  InternetEncoding
//  AliasForCharset
//=============================================================================
procedure TForm1.ListBox1Click(Sender: TObject);
var
  Registry   : TRegistry;
  RegKey     : String;
  AIndex     : Integer;
  TempStr    : String;
  CodePage   : Integer;
  IECodePage : Integer;
  MLang      : IMultiLanguage;
  MIMECPInfo : TMIMECPINFO;
  strLocale  : String;
begin
  AIndex := ListBox1.ItemIndex;
  if AIndex<0 then exit;

  Memo1.Lines.Clear;

  Memo1.Lines.Add('Charset          : ' + ListBox1.Items[ListBox1.ItemIndex]);

  RegKey   := '\mime\database\Charset\';
  Registry := TRegistry.Create(KEY_READ);
  try
    Registry.RootKey := HKEY_CLASSES_ROOT;
    try
      Registry.OpenKey(RegKey+ ListBox1.Items[AIndex], False);
      CodePage := Registry.ReadInteger('CodePage');
      Memo1.Lines.Add('CodePage         : ' + IntToStr(CodePage));
    except
      Memo1.Lines.Add('CodePage         : ');
    end;

    IECodePage := -1;
    try
      Registry.OpenKey(RegKey+ ListBox1.Items[AIndex], False);
      IECodePage := Registry.ReadInteger('InternetEncoding');
      Memo1.Lines.Add('InternetEncoding : ' + IntToStr(IECodePage));
    except
      Memo1.Lines.Add('InternetEncoding : ');
    end;

    try
      Registry.OpenKey(RegKey+ ListBox1.Items[AIndex], False);
      TempStr := Registry.ReadString('AliasForCharset');
      Memo1.Lines.Add('AliasForCharset  : ' + TempStr);
    except
      Memo1.Lines.Add('AliasForCharset  : ');
    end;

    Registry.CloseKey;

    //ꖼΎ擾
    //InternetEncoding̒l擾
    if IECodePage >= 0 then begin
      //mlang̃IuWFNg𐶐
      MLang := CoCMultiLanguage.Create;
      try
        MLang.GetCodePageInfo(IECodePage, MIMECPInfo);
        strLocale := MIMECPInfo.wszDescription;
      finally
        MLang := nil;
      end;
    end;
    Memo1.Lines.Add('Locale           : ' + strLocale);
  finally
     Registry.Free;
  end;
end;

end.
