﻿//=============================================================================
//  このファイルは筆者のサイトの記事
//  [http://mrxray.on.coocan.jp/Delphi/CompoInstall/TypeLibraryDD.htm]
//  に基づいて作成した．
//
//  MSDNの記事と引数の型などが異なる部分を，Delphi2009以降用(Unicode対応)に一部
//  修正している
//
//  Delphi2009よりも前のバージョンでは元のMultiLanguage_TLB.pasの以下の部分の修
//  正が必要(関数の文字列引数部分)
//  Shortint --> WideChar
//  Word     --> Char
//  各構造体のWord部分はWideCharにする
//-----------------------------------------------------------------------------
//
//  2010年02月20日 Mr.XRAY
//  2010年02月25日 WideString --> String
//                 PWideChar --> PChar      
//-----------------------------------------------------------------------------
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit MultiLanguage_TLB;

// ************************************************************************ //
// 警告                                                                       
// -------                                                                    
// このファイルで宣言されている型はタイプライブラリから読み取られたデータから 
// 生成されています。このタイプライブラリが明示的あるいは（このタイプライブラ 
// リを参照しているほかのタイプライブラリ経由で）間接的に再インポートされた   
// り，タイプライブライブラリの編集中にタイプライブラリエディタの［更新］コマ 
// ンドを実行した場合，このファイルの内容はすべて再生成され，手動で加えた変更 
// はすべて失われます。                                                       
// ************************************************************************ //


// $Rev: 17252 $
// 下に説明されたタイプ ライブラリから 2010/02/20 16:05:54 に生成されたファイル。

// ************************************************************************  //
// タイプ ライブラリ: Mlang.tlb (1)
// LIBID: {275C23E0-3747-11D0-9FEA-00AA003F8646}
// LCID: 0
// ヘルプファイル: 
// ヘルプ文字列: MultiLanguage Object Model
// 依存関係リスト: 
//   (1) v2.0 stdole, (C:\Windows\system32\stdole2.tlb)
// エラー:
//   ヒント: 'type' の名前が 'type_' に変更されました。
//   ヒント: 'type' の名前が 'type_' に変更されました。
//   "TCMLangString" のパレット用ビットマップの作成時エラー : サーバー C:\Windows\system32\mlang.dll はアイコンを持っていません。
//   "TCMLangConvertCharset" のパレット用ビットマップの作成時エラー : サーバー C:\Windows\system32\mlang.dll はアイコンを持っていません。
//   "TCMultiLanguage" のパレット用ビットマップの作成時エラー : サーバー C:\Windows\system32\mlang.dll はアイコンを持っていません。
// コマンドライン:
//   tlibimp -P Mlang.tlb
// ************************************************************************ //
// *************************************************************************//
// メモ:                                                                      
// $IFDEF_LIVE_SERVER_AT_DESIGN_TIME でガードされた項目が使用されるのは、
// プロパティでアクセスする前に関数呼び出しで明示的に作成する必要がある
// オブジェクトが返されるプロパティです。これらの項目は  
// オブジェクト インスペクタ内から間違って使用されないように無効化されています。
// ここで LIVE_SERVER_AT_DESIGN_TIME を定義する、または 
// $IFDEF ブロックから選択して削除することによって有効にできます。
// ただし、このような項目は使用する前に適切な CoClass のメソッドで
// プログラムで作成される必要があります。                                                          
{$TYPEDADDRESS OFF} 
// ポインタの型チェックをオフにしてコンパイルすること
{$WARN SYMBOL_PLATFORM OFF}
{$WRITEABLECONST ON}
{$VARPROPSETTER ON}
{$ALIGN 4}
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, StdVCL, Variants;
  
// *********************************************************************//

// タイプライブラリで宣言される GUID. 以下のプレフィックスを使う:        

//   Type Libraries     : LIBID_xxxx                                      

//   CoClasses          : CLASS_xxxx                                      

//   DISPInterfaces     : DIID_xxxx                                       

//   Non-DISP interfaces: IID_xxxx                                        

// *********************************************************************//


const
  // タイプ ライブラリのメジャー バージョンとマイナー バージョン
  MultiLanguageMajorVersion = 0;
  MultiLanguageMinorVersion = 2;

  LIBID_MultiLanguage: TGUID = '{275C23E0-3747-11D0-9FEA-00AA003F8646}';

  IID_IMLangStringBufW: TGUID = '{D24ACD21-BA72-11D0-B188-00AA0038C969}';
  IID_IMLangStringBufA: TGUID = '{D24ACD23-BA72-11D0-B188-00AA0038C969}';
  IID_IMLangString: TGUID = '{C04D65CE-B70D-11D0-B188-00AA0038C969}';
  IID_IMLangStringWStr: TGUID = '{C04D65D0-B70D-11D0-B188-00AA0038C969}';
  IID_IMLangStringAStr: TGUID = '{C04D65D2-B70D-11D0-B188-00AA0038C969}';
  CLASS_CMLangString: TGUID = '{C04D65CF-B70D-11D0-B188-00AA0038C969}';
  IID_IMLangLineBreakConsole: TGUID = '{F5BE2EE1-BFD7-11D0-B188-00AA0038C969}';
  IID_IEnumCodePage: TGUID = '{275C23E3-3747-11D0-9FEA-00AA003F8646}';
  IID_IEnumRfc1766: TGUID = '{3DC39D1D-C030-11D0-B81B-00C04FC9B31F}';
  IID_IEnumScript: TGUID = '{AE5F1430-388B-11D2-8380-00C04F8F5DA1}';
  IID_IMLangConvertCharset: TGUID = '{D66D6F98-CDAA-11D0-B822-00C04FC9B31F}';
  CLASS_CMLangConvertCharset: TGUID = '{D66D6F99-CDAA-11D0-B822-00C04FC9B31F}';
  IID_IMultiLanguage: TGUID = '{275C23E1-3747-11D0-9FEA-00AA003F8646}';
  IID_IMultiLanguage2: TGUID = '{DCCFC164-2B38-11D2-B7EC-00C04F8F5D9A}';
  IID_ISequentialStream: TGUID = '{0C733A30-2A1C-11CE-ADE5-00AA0044773D}';
  IID_IStream: TGUID = '{0000000C-0000-0000-C000-000000000046}';
  IID_IMLangCodePages: TGUID = '{359F3443-BD4A-11D0-B188-00AA0038C969}';
  IID_IMLangFontLink: TGUID = '{359F3441-BD4A-11D0-B188-00AA0038C969}';
  IID_IMLangFontLink2: TGUID = '{DCCFC162-2B38-11D2-B7EC-00C04F8F5D9A}';
  IID_IMultiLanguage3: TGUID = '{4E5868AB-B157-4623-9ACC-6A1D9CAEBE04}';
  CLASS_CMultiLanguage: TGUID = '{275C23E2-3747-11D0-9FEA-00AA003F8646}';

// *********************************************************************//
// タイプ ライブラリで定義された列挙型の宣言                    
// *********************************************************************//
// 列挙型 tagMLSTR_FLAGS の定数 
type
  tagMLSTR_FLAGS = TOleEnum;
const
  MLSTR_READ = $00000001;
  MLSTR_WRITE = $00000002;

// 列挙型 tagMIMECONTF の定数 
type
  tagMIMECONTF = TOleEnum;
const
  MIMECONTF_MAILNEWS = $00000001;
  MIMECONTF_BROWSER = $00000002;
  MIMECONTF_MINIMAL = $00000004;
  MIMECONTF_IMPORT = $00000008;
  MIMECONTF_SAVABLE_MAILNEWS = $00000100;
  MIMECONTF_SAVABLE_BROWSER = $00000200;
  MIMECONTF_EXPORT = $00000400;
  MIMECONTF_PRIVCONVERTER = $00010000;
  MIMECONTF_VALID = $00020000;
  MIMECONTF_VALID_NLS = $00040000;
  MIMECONTF_MIME_IE4 = $10000000;
  MIMECONTF_MIME_LATEST = $20000000;
  MIMECONTF_MIME_REGISTRY = $40000000;

type
// *********************************************************************//

// タイプライブラリで宣言される前方参照

// *********************************************************************//

  IMLangStringBufW = interface;
  IMLangStringBufA = interface;
  IMLangString = interface;
  IMLangStringWStr = interface;
  IMLangStringAStr = interface;
  IMLangLineBreakConsole = interface;
  IEnumCodePage = interface;
  IEnumRfc1766 = interface;
  IEnumScript = interface;
  IMLangConvertCharset = interface;
  IMultiLanguage = interface;
  IMultiLanguage2 = interface;
  ISequentialStream = interface;
  IStream = interface;
  IMLangCodePages = interface;
  IMLangFontLink = interface;
  IMLangFontLink2 = interface;
  IMultiLanguage3 = interface;
// *********************************************************************//

// タイプライブラリで宣言される CoClass                       

// (注意: ここで各 CoClass とデフォルトのインターフェイスをマッピングする)              

// *********************************************************************//


  CMLangString = IMLangString;
  CMLangConvertCharset = IMLangConvertCharset;
  CMultiLanguage = IMultiLanguage;


// *********************************************************************//
// 構造体、共用体およびエイリアスの宣言                         
// *********************************************************************//
  wireHWND = ^_RemotableHandle; 
  wireHDC = ^_RemotableHandle; 
  wireHFONT = ^_RemotableHandle; 
  PWord1 = ^Word; {*}         //一箇所のみで使用
  PShortint1 = ^Shortint; {*} //一箇所のみで使用
  PUserType1 = ^TGUID; {*}
  PByte1 = ^Byte; {*}         //未使用
  PSYSUINT1 = ^SYSUINT; {*}

  PMIMECPINFO = ^TMIMECPINFO;
  tagMIMECPINFO = record
    dwFlags: LongWord;
    uiCodePage: SYSUINT;
    uiFamilyCodePage: SYSUINT;
    wszDescription: array[0..63] of Char;
    wszWebCharset: array[0..49] of Char;
    wszHeaderCharset: array[0..49] of Char;
    wszBodyCharset: array[0..49] of Char;
    wszFixedWidthFont: array[0..31] of Char;
    wszProportionalFont: array[0..31] of Char;
    bGDICharset: Byte;
  end;
  TMIMECPINFO = tagMIMECPINFO;

  PRFC1766INFO = ^TRFC1766INFO;
  tagRFC1766INFO = record
    lcid: LongWord;
    wszRfc1766: array[0..5] of Char;
    wszLocaleName: array[0..31] of Char;
  end;
  TRFC1766INFO = tagRFC1766INFO;

  PSCRIPTINFO = ^TSCRIPTINFO;
  tagSCRIPTINFO = record
    ScriptId: Byte;
    uiCodePage: SYSUINT;
    wszDescription: array[0..47] of Char;
    wszFixedWidthFont: array[0..31] of Char;
    wszProportionalFont: array[0..31] of Char;
  end;
  TSCRIPTINFO = tagSCRIPTINFO;

  PMIMECSETINFO = ^TMIMECSETINFO;
  tagMIMECSETINFO = record
    uiCodePage: SYSUINT;
    uiInternetEncoding: SYSUINT;
    wszCharset: array[0..49] of Char;
  end;
  TMIMECSETINFO = tagMIMECSETINFO;

{$ALIGN 8}
  _LARGE_INTEGER = record
    QuadPart: Int64;
  end;

{$ALIGN 8}
  _ULARGE_INTEGER = record
    QuadPart: Largeuint;
  end;

  _FILETIME = record
    dwLowDateTime: LongWord;
    dwHighDateTime: LongWord;
  end;

{$ALIGN 8}
  PSTATSTG = ^TSTATSTG;
  tagSTATSTG = record
    pwcsName: PChar;
    type_: LongWord;
    cbSize: _ULARGE_INTEGER;
    mtime: _FILETIME;
    ctime: _FILETIME;
    atime: _FILETIME;
    grfMode: LongWord;
    grfLocksSupported: LongWord;
    clsid: TGUID;
    grfStateBits: LongWord;
    reserved: LongWord;
  end;
  TSTATSTG = tagSTATSTG;

  PDetectEncodingInfo = ^TDetectEncodingInfo;
  tagDetectEncodingInfo = record
    nLangID: SYSUINT;
    nCodePage: SYSUINT;
    nDocPercent: SYSINT;
    nConfidence: SYSINT;
  end;
  TDetectEncodingInfo = tagDetectEncodingInfo;


  __MIDL_IWinTypes_0009 = record
    case Integer of
      0: (hInproc: Integer);
      1: (hRemote: Integer);
  end;

  _RemotableHandle = record
    fContext: Integer;
    u: __MIDL_IWinTypes_0009;
  end;


{$ALIGN 2}
  PUNICODERANGE = ^TUNICODERANGE;
  tagUNICODERANGE = record
    wcFrom: Word;
    wcTo: Word;
  end;
  TUNICODERANGE = tagUNICODERANGE;

{$ALIGN 8}
  PSCRIPFONTINFO = ^TSCRIPFONTINFO;
  tagSCRIPFONTINFO = record
    scripts: Int64;
    wszFont: array[0..31] of Char;
  end;
  TSCRIPFONTINFO = tagSCRIPFONTINFO;


// *********************************************************************//
// インターフェイス: IMLangStringBufW
// フラグ: (0)
// GUID: {D24ACD21-BA72-11D0-B188-00AA0038C969}
// *********************************************************************//
  IMLangStringBufW = interface(IUnknown)
    ['{D24ACD21-BA72-11D0-B188-00AA0038C969}']
    function GetStatus(out plFlags: Integer; out pcchBuf: Integer): HResult; stdcall;
    function LockBuf(cchOffset: Integer; cchMaxLock: Integer; out ppszBuf: PWord1; 
                     out pcchBuf: Integer): HResult; stdcall;
    function UnlockBuf(var pszBuf: Word; cchOffset: Integer; cchWrite: Integer): HResult; stdcall;
    function Insert(cchOffset: Integer; cchMaxInsert: Integer; out pcchActual: Integer): HResult; stdcall;
    function Delete(cchOffset: Integer; cchDelete: Integer): HResult; stdcall;
  end;

// *********************************************************************//
// インターフェイス: IMLangStringBufA
// フラグ: (0)
// GUID: {D24ACD23-BA72-11D0-B188-00AA0038C969}
// *********************************************************************//
  IMLangStringBufA = interface(IUnknown)
    ['{D24ACD23-BA72-11D0-B188-00AA0038C969}']
    function GetStatus(out plFlags: Integer; out pcchBuf: Integer): HResult; stdcall;
    function LockBuf(cchOffset: Integer; cchMaxLock: Integer; out ppszBuf: PShortint1; 
                     out pcchBuf: Integer): HResult; stdcall;
    function UnlockBuf(var pszBuf: Shortint; cchOffset: Integer; cchWrite: Integer): HResult; stdcall;
    function Insert(cchOffset: Integer; cchMaxInsert: Integer; out pcchActual: Integer): HResult; stdcall;
    function Delete(cchOffset: Integer; cchDelete: Integer): HResult; stdcall;
  end;

// *********************************************************************//
// インターフェイス: IMLangString
// フラグ: (0)
// GUID: {C04D65CE-B70D-11D0-B188-00AA0038C969}
// *********************************************************************//
  IMLangString = interface(IUnknown)
    ['{C04D65CE-B70D-11D0-B188-00AA0038C969}']
    function Sync(fNoAccess: Integer): HResult; stdcall;
    function GetLength(out plLen: Integer): HResult; stdcall;
    function SetMLStr(lDestPos: Integer; lDestLen: Integer; const pSrcMLStr: IUnknown; 
                      lSrcPos: Integer; lSrcLen: Integer): HResult; stdcall;
    function GetMLStr(lSrcPos: Integer; lSrcLen: Integer; const pUnkOuter: IUnknown; 
                      dwClsContext: LongWord; var piid: TGUID; out ppDestMLStr: IUnknown; 
                      out plDestPos: Integer; out plDestLen: Integer): HResult; stdcall;
  end;

// *********************************************************************//
// インターフェイス: IMLangStringWStr
// フラグ: (0)
// GUID: {C04D65D0-B70D-11D0-B188-00AA0038C969}
// *********************************************************************//
  IMLangStringWStr = interface(IMLangString)
    ['{C04D65D0-B70D-11D0-B188-00AA0038C969}']
    function SetWStr(lDestPos: Integer; lDestLen: Integer; pszSrc: PChar; cchSrc: Integer; 
                     out pcchActual: Integer; out plActualLen: Integer): HResult; stdcall;
    function SetStrBufW(lDestPos: Integer; lDestLen: Integer; const pSrcBuf: IMLangStringBufW; 
                        out pcchActual: Integer; out plActualLen: Integer): HResult; stdcall;
    function GetWStr(lSrcPos: Integer; lSrcLen: Integer; pszDest: PChar; cchDest: Integer; 
                     out pcchActual: Integer; out plActualLen: Integer): HResult; stdcall;
    function GetStrBufW(lSrcPos: Integer; lSrcMaxLen: Integer; out ppDestBuf: IMLangStringBufW; 
                        out plDestLen: Integer): HResult; stdcall;
    function LockWStr(lSrcPos: Integer; lSrcLen: Integer; lFlags: Integer; cchRequest: Integer; 
                      out ppszDest: PChar; out pcchDest: Integer; out plDestLen: Integer): HResult; stdcall;
    function UnlockWStr(pszSrc: PChar; cchSrc: Integer; out pcchActual: Integer; 
                        out plActualLen: Integer): HResult; stdcall;
    function SetLocale(lDestPos: Integer; lDestLen: Integer; locale: LongWord): HResult; stdcall;
    function GetLocale(lSrcPos: Integer; lSrcMaxLen: Integer; out plocale: LongWord; 
                       out plLocalePos: Integer; out plLocaleLen: Integer): HResult; stdcall;
  end;

// *********************************************************************//
// インターフェイス: IMLangStringAStr
// フラグ: (0)
// GUID: {C04D65D2-B70D-11D0-B188-00AA0038C969}
// *********************************************************************//
  IMLangStringAStr = interface(IMLangString)
    ['{C04D65D2-B70D-11D0-B188-00AA0038C969}']
    function SetAStr(lDestPos: Integer; lDestLen: Integer; uCodePage: SYSUINT; pszSrc: PChar; 
                     cchSrc: Integer; out pcchActual: Integer; out plActualLen: Integer): HResult; stdcall;
    function SetStrBufA(lDestPos: Integer; lDestLen: Integer; uCodePage: SYSUINT; 
                        const pSrcBuf: IMLangStringBufA; out pcchActual: Integer; 
                        out plActualLen: Integer): HResult; stdcall;
    function GetAStr(lSrcPos: Integer; lSrcLen: Integer; uCodePageIn: SYSUINT; 
                     out puCodePageOut: SYSUINT; pszDest: PChar; cchDest: Integer; 
                     out pcchActual: Integer; out plActualLen: Integer): HResult; stdcall;
    function GetStrBufA(lSrcPos: Integer; lSrcMaxLen: Integer; out puDestCodePage: SYSUINT; 
                        out ppDestBuf: IMLangStringBufA; out plDestLen: Integer): HResult; stdcall;
    function LockAStr(lSrcPos: Integer; lSrcLen: Integer; lFlags: Integer; uCodePageIn: SYSUINT; 
                      cchRequest: Integer; out puCodePageOut: SYSUINT; out ppszDest: PChar; 
                      out pcchDest: Integer; out plDestLen: Integer): HResult; stdcall;
    function UnlockAStr(pszSrc: PChar; cchSrc: Integer; out pcchActual: Integer; 
                        out plActualLen: Integer): HResult; stdcall;
    function SetLocale(lDestPos: Integer; lDestLen: Integer; locale: LongWord): HResult; stdcall;
    function GetLocale(lSrcPos: Integer; lSrcMaxLen: Integer; out plocale: LongWord; 
                       out plLocalePos: Integer; out plLocaleLen: Integer): HResult; stdcall;
  end;

// *********************************************************************//
// インターフェイス: IMLangLineBreakConsole
// フラグ: (0)
// GUID: {F5BE2EE1-BFD7-11D0-B188-00AA0038C969}
// *********************************************************************//
  IMLangLineBreakConsole = interface(IUnknown)
    ['{F5BE2EE1-BFD7-11D0-B188-00AA0038C969}']
    function BreakLineML(const pSrcMLStr: IMLangString; lSrcPos: Integer; lSrcLen: Integer; 
                         cMinColumns: Integer; cMaxColumns: Integer; out plLineLen: Integer; 
                         out plSkipLen: Integer): HResult; stdcall;
    function BreakLineW(locale: LongWord; var pszSrc: Word; cchSrc: Integer; cMaxColumns: Integer; 
                        out pcchLine: Integer; out pcchSkip: Integer): HResult; stdcall;
    function BreakLineA(locale: LongWord; uCodePage: SYSUINT; var pszSrc: Char;
                        cchSrc: Integer; cMaxColumns: Integer; out pcchLine: Integer; 
                        out pcchSkip: Integer): HResult; stdcall;
  end;

// *********************************************************************//
// インターフェイス: IEnumCodePage
// フラグ: (0)
// GUID: {275C23E3-3747-11D0-9FEA-00AA003F8646}
// *********************************************************************//
  IEnumCodePage = interface(IUnknown)
    ['{275C23E3-3747-11D0-9FEA-00AA003F8646}']
    function Clone(out ppEnum: IEnumCodePage): HResult; stdcall;
    function Next(celt: LongWord; out rgelt: tagMIMECPINFO; out pceltFetched: LongWord): HResult; stdcall;
    function Reset: HResult; stdcall;
    function Skip(celt: LongWord): HResult; stdcall;
  end;

// *********************************************************************//
// インターフェイス: IEnumRfc1766
// フラグ: (0)
// GUID: {3DC39D1D-C030-11D0-B81B-00C04FC9B31F}
// *********************************************************************//
  IEnumRfc1766 = interface(IUnknown)
    ['{3DC39D1D-C030-11D0-B81B-00C04FC9B31F}']
    function Clone(out ppEnum: IEnumRfc1766): HResult; stdcall;
    function Next(celt: LongWord; out rgelt: tagRFC1766INFO; out pceltFetched: LongWord): HResult; stdcall;
    function Reset: HResult; stdcall;
    function Skip(celt: LongWord): HResult; stdcall;
  end;

// *********************************************************************//
// インターフェイス: IEnumScript
// フラグ: (0)
// GUID: {AE5F1430-388B-11D2-8380-00C04F8F5DA1}
// *********************************************************************//
  IEnumScript = interface(IUnknown)
    ['{AE5F1430-388B-11D2-8380-00C04F8F5DA1}']
    function Clone(out ppEnum: IEnumScript): HResult; stdcall;
    function Next(celt: LongWord; out rgelt: tagSCRIPTINFO; out pceltFetched: LongWord): HResult; stdcall;
    function Reset: HResult; stdcall;
    function Skip(celt: LongWord): HResult; stdcall;
  end;

// *********************************************************************//
// インターフェイス: IMLangConvertCharset
// フラグ: (0)
// GUID: {D66D6F98-CDAA-11D0-B822-00C04FC9B31F}
// *********************************************************************//
  IMLangConvertCharset = interface(IUnknown)
    ['{D66D6F98-CDAA-11D0-B822-00C04FC9B31F}']
    function Initialize(uiSrcCodePage: SYSUINT; uiDstCodePage: SYSUINT; dwProperty: LongWord): HResult; stdcall;
    function GetSourceCodePage(out puiSrcCodePage: SYSUINT): HResult; stdcall;
    function GetDestinationCodePage(out puiDstCodePage: SYSUINT): HResult; stdcall;
    function GetProperty(out pdwProperty: LongWord): HResult; stdcall;
    function DoConversion(var pSrcStr: Byte; var pcSrcSize: SYSUINT; out pDstStr: Byte; 
                          var pcDstSize: SYSUINT): HResult; stdcall;
    function DoConversionToUnicode(var pSrcStr: Char; var pcSrcSize: SYSUINT;
                                   out pDstStr: Char; var pcDstSize: SYSUINT): HResult; stdcall;
    function DoConversionFromUnicode(var pSrcStr: Char; var pcSrcSize: SYSUINT;
                                     out pDstStr: Char; var pcDstSize: SYSUINT): HResult; stdcall;
  end;

// *********************************************************************//
// インターフェイス: IMultiLanguage
// フラグ: (0)
// GUID: {275C23E1-3747-11D0-9FEA-00AA003F8646}
// *********************************************************************//
  IMultiLanguage = interface(IUnknown)
    ['{275C23E1-3747-11D0-9FEA-00AA003F8646}']
    function GetNumberOfCodePageInfo(out pcCodePage: SYSUINT): HResult; stdcall;
    function GetCodePageInfo(uiCodePage: SYSUINT; out pCodePageInfo: tagMIMECPINFO): HResult; stdcall;
    function GetFamilyCodePage(uiCodePage: SYSUINT; out puiFamilyCodePage: SYSUINT): HResult; stdcall;
    function EnumCodePages(grfFlags: LongWord; out ppEnumCodePage: IEnumCodePage): HResult; stdcall;
    function GetCharsetInfo(const Charset: String; out pCharsetInfo: tagMIMECSETINFO): HResult; stdcall;
    function IsConvertible(dwSrcEncoding: LongWord; dwDstEncoding: LongWord): HResult; stdcall;
    function ConvertString(var pdwMode: LongWord; dwSrcEncoding: LongWord; dwDstEncoding: LongWord; 
                           var pSrcStr: Byte; var pcSrcSize: SYSUINT; out pDstStr: Byte; 
                           var pcDstSize: SYSUINT): HResult; stdcall;
    function ConvertStringToUnicode(var pdwMode: LongWord; dwEncoding: LongWord; 
                                    var pSrcStr: Char; var pcSrcSize: SYSUINT;
                                    out pDstStr: Char; var pcDstSize: SYSUINT): HResult; stdcall;
    function ConvertStringFromUnicode(var pdwMode: LongWord; dwEncoding: LongWord; 
                                      var pSrcStr: Char; var pcSrcSize: SYSUINT;
                                      out pDstStr: Char; var pcDstSize: SYSUINT): HResult; stdcall;
    function ConvertStringReset: HResult; stdcall;
    function GetRfc1766FromLcid(locale: LongWord; out pbstrRfc1766: String): HResult; stdcall;
    function GetLcidFromRfc1766(out plocale: LongWord; const bstrRfc1766: String): HResult; stdcall;
    function EnumRfc1766(out ppEnumRfc1766: IEnumRfc1766): HResult; stdcall;
    function GetRfc1766Info(locale: LongWord; out pRfc1766Info: tagRFC1766INFO): HResult; stdcall;
    function CreateConvertCharset(uiSrcCodePage: SYSUINT; uiDstCodePage: SYSUINT; 
                                  dwProperty: LongWord; 
                                  out ppMLangConvertCharset: IMLangConvertCharset): HResult; stdcall;
  end;

// *********************************************************************//
// インターフェイス: IMultiLanguage2
// フラグ: (0)
// GUID: {DCCFC164-2B38-11D2-B7EC-00C04F8F5D9A}
// *********************************************************************//
  IMultiLanguage2 = interface(IUnknown)
    ['{DCCFC164-2B38-11D2-B7EC-00C04F8F5D9A}']
    function GetNumberOfCodePageInfo(out pcCodePage: SYSUINT): HResult; stdcall;
    function GetCodePageInfo(uiCodePage: SYSUINT; LangId: Word; out pCodePageInfo: tagMIMECPINFO): HResult; stdcall;
    function GetFamilyCodePage(uiCodePage: SYSUINT; out puiFamilyCodePage: SYSUINT): HResult; stdcall;
    function EnumCodePages(grfFlags: LongWord; LangId: Word; out ppEnumCodePage: IEnumCodePage): HResult; stdcall;
    function GetCharsetInfo(const Charset: String; out pCharsetInfo: tagMIMECSETINFO): HResult; stdcall;
    function IsConvertible(dwSrcEncoding: LongWord; dwDstEncoding: LongWord): HResult; stdcall;
    function ConvertString(var pdwMode: LongWord; dwSrcEncoding: LongWord; dwDstEncoding: LongWord; 
                           var pSrcStr: Byte; var pcSrcSize: SYSUINT; out pDstStr: Byte; 
                           var pcDstSize: SYSUINT): HResult; stdcall;
    function ConvertStringToUnicode(var pdwMode: LongWord; dwEncoding: LongWord; 
                                    var pSrcStr: Char; var pcSrcSize: SYSUINT;
                                    out pDstStr: Char; var pcDstSize: SYSUINT): HResult; stdcall;
    function ConvertStringFromUnicode(var pdwMode: LongWord; dwEncoding: LongWord; 
                                      var pSrcStr: Char; var pcSrcSize: SYSUINT;
                                      out pDstStr: Char; var pcDstSize: SYSUINT): HResult; stdcall;
    function ConvertStringReset: HResult; stdcall;
    function GetRfc1766FromLcid(locale: LongWord; out pbstrRfc1766: String): HResult; stdcall;
    function GetLcidFromRfc1766(out plocale: LongWord; const bstrRfc1766: String): HResult; stdcall;
    function EnumRfc1766(LangId: Word; out ppEnumRfc1766: IEnumRfc1766): HResult; stdcall;
    function GetRfc1766Info(locale: LongWord; LangId: Word; out pRfc1766Info: tagRFC1766INFO): HResult; stdcall;
    function CreateConvertCharset(uiSrcCodePage: SYSUINT; uiDstCodePage: SYSUINT; 
                                  dwProperty: LongWord; 
                                  out ppMLangConvertCharset: IMLangConvertCharset): HResult; stdcall;
    function ConvertStringInIStream(var pdwMode: LongWord; dwFlag: LongWord; var lpFallBack: Word; 
                                    dwSrcEncoding: LongWord; dwDstEncoding: LongWord; 
                                    const pstmIn: IStream; const pstmOut: IStream): HResult; stdcall;
    function ConvertStringToUnicodeEx(var pdwMode: LongWord; dwEncoding: LongWord; 
                                      var pSrcStr: Char; var pcSrcSize: SYSUINT;
                                      out pDstStr: Word; var pcDstSize: SYSUINT; dwFlag: LongWord;
                                      var lpFallBack: Char): HResult; stdcall;
    function ConvertStringFromUnicodeEx(var pdwMode: LongWord; dwEncoding: LongWord; 
                                        var pSrcStr: Char; var pcSrcSize: SYSUINT;
                                        out pDstStr: Char; var pcDstSize: SYSUINT;
                                        dwFlag: LongWord; var lpFallBack: Word): HResult; stdcall;
    function DetectCodepageInIStream(dwFlag: LongWord; dwPrefWinCodePage: LongWord; 
                                     const pstmIn: IStream; out lpEncoding: tagDetectEncodingInfo; 
                                     var pnScores: SYSINT): HResult; stdcall;
    function DetectInputCodepage(dwFlag: LongWord; dwPrefWinCodePage: LongWord; 
                                 var pSrcStr: Char; var pcSrcSize: SYSINT;
                                 out lpEncoding: tagDetectEncodingInfo; var pnScores: SYSINT): HResult; stdcall;
    function ValidateCodePage(uiCodePage: SYSUINT; var hwnd: _RemotableHandle): HResult; stdcall;
    function GetCodePageDescription(uiCodePage: SYSUINT; lcid: LongWord; lpWideCharStr: PChar; 
                                    cchWideChar: SYSINT): HResult; stdcall;
    function IsCodePageInstallable(uiCodePage: SYSUINT): HResult; stdcall;
    function SetMimeDBSource(dwSource: tagMIMECONTF): HResult; stdcall;
    function GetNumberOfScripts(out pnScripts: SYSUINT): HResult; stdcall;
    function EnumScripts(dwFlags: LongWord; LangId: Word; out ppEnumScript: IEnumScript): HResult; stdcall;
    function ValidateCodePageEx(uiCodePage: SYSUINT; var hwnd: _RemotableHandle; 
                                dwfIODControl: LongWord): HResult; stdcall;
  end;

// *********************************************************************//
// インターフェイス: ISequentialStream
// フラグ: (0)
// GUID: {0C733A30-2A1C-11CE-ADE5-00AA0044773D}
// *********************************************************************//
  ISequentialStream = interface(IUnknown)
    ['{0C733A30-2A1C-11CE-ADE5-00AA0044773D}']
    function RemoteRead(out pv: Byte; cb: LongWord; out pcbRead: LongWord): HResult; stdcall;
    function RemoteWrite(var pv: Byte; cb: LongWord; out pcbWritten: LongWord): HResult; stdcall;
  end;

// *********************************************************************//
// インターフェイス: IStream
// フラグ: (0)
// GUID: {0000000C-0000-0000-C000-000000000046}
// *********************************************************************//
  IStream = interface(ISequentialStream)
    ['{0000000C-0000-0000-C000-000000000046}']
    function RemoteSeek(dlibMove: _LARGE_INTEGER; dwOrigin: LongWord; 
                        out plibNewPosition: _ULARGE_INTEGER): HResult; stdcall;
    function SetSize(libNewSize: _ULARGE_INTEGER): HResult; stdcall;
    function RemoteCopyTo(const pstm: IStream; cb: _ULARGE_INTEGER; out pcbRead: _ULARGE_INTEGER; 
                          out pcbWritten: _ULARGE_INTEGER): HResult; stdcall;
    function Commit(grfCommitFlags: LongWord): HResult; stdcall;
    function Revert: HResult; stdcall;
    function LockRegion(libOffset: _ULARGE_INTEGER; cb: _ULARGE_INTEGER; dwLockType: LongWord): HResult; stdcall;
    function UnlockRegion(libOffset: _ULARGE_INTEGER; cb: _ULARGE_INTEGER; dwLockType: LongWord): HResult; stdcall;
    function Stat(out pstatstg: tagSTATSTG; grfStatFlag: LongWord): HResult; stdcall;
    function Clone(out ppstm: IStream): HResult; stdcall;
  end;

// *********************************************************************//
// インターフェイス: IMLangCodePages
// フラグ: (0)
// GUID: {359F3443-BD4A-11D0-B188-00AA0038C969}
// *********************************************************************//
  IMLangCodePages = interface(IUnknown)
    ['{359F3443-BD4A-11D0-B188-00AA0038C969}']
    function GetCharCodePages(chSrc: Word; out pdwCodePages: LongWord): HResult; stdcall;
    function GetStrCodePages(var pszSrc: Word; cchSrc: Integer; dwPriorityCodePages: LongWord; 
                             out pdwCodePages: LongWord; out pcchCodePages: Integer): HResult; stdcall;
    function CodePageToCodePages(uCodePage: SYSUINT; out pdwCodePages: LongWord): HResult; stdcall;
    function CodePagesToCodePage(dwCodePages: LongWord; uDefaultCodePage: SYSUINT; 
                                 out puCodePage: SYSUINT): HResult; stdcall;
  end;

// *********************************************************************//
// インターフェイス: IMLangFontLink
// フラグ: (0)
// GUID: {359F3441-BD4A-11D0-B188-00AA0038C969}
// *********************************************************************//
  IMLangFontLink = interface(IMLangCodePages)
    ['{359F3441-BD4A-11D0-B188-00AA0038C969}']
    function GetFontCodePages(var hDC: _RemotableHandle; var hFont: _RemotableHandle; 
                              out pdwCodePages: LongWord): HResult; stdcall;
    function MapFont(var hDC: _RemotableHandle; dwCodePages: LongWord; 
                     var hSrcFont: _RemotableHandle; out phDestFont: wireHFONT): HResult; stdcall;
    function ReleaseFont(var hFont: _RemotableHandle): HResult; stdcall;
    function ResetFontMapping: HResult; stdcall;
  end;

// *********************************************************************//
// インターフェイス: IMLangFontLink2
// フラグ: (0)
// GUID: {DCCFC162-2B38-11D2-B7EC-00C04F8F5D9A}
// *********************************************************************//
  IMLangFontLink2 = interface(IMLangCodePages)
    ['{DCCFC162-2B38-11D2-B7EC-00C04F8F5D9A}']
    function GetFontCodePages(var hDC: _RemotableHandle; var hFont: _RemotableHandle; 
                              out pdwCodePages: LongWord): HResult; stdcall;
    function ReleaseFont(var hFont: _RemotableHandle): HResult; stdcall;
    function ResetFontMapping: HResult; stdcall;
    function MapFont(var hDC: _RemotableHandle; dwCodePages: LongWord; chSrc: Word; 
                     out pFont: wireHFONT): HResult; stdcall;
    function GetFontUnicodeRanges(var hDC: _RemotableHandle; var puiRanges: SYSUINT; 
                                  out pUranges: tagUNICODERANGE): HResult; stdcall;
    function GetScriptFontInfo(sid: Byte; dwFlags: LongWord; var puiFonts: SYSUINT; 
                               out pScriptFont: tagSCRIPFONTINFO): HResult; stdcall;
    function CodePageToScriptID(uiCodePage: SYSUINT; out pSid: Byte): HResult; stdcall;
  end;

// *********************************************************************//
// インターフェイス: IMultiLanguage3
// フラグ: (0)
// GUID: {4E5868AB-B157-4623-9ACC-6A1D9CAEBE04}
// *********************************************************************//
  IMultiLanguage3 = interface(IMultiLanguage2)
    ['{4E5868AB-B157-4623-9ACC-6A1D9CAEBE04}']
    function DetectOutboundCodePage(dwFlags: LongWord; lpWideCharStr: PChar; 
                                    cchWideChar: SYSUINT; var puiPreferredCodePages: SYSUINT; 
                                    nPreferredCodePages: SYSUINT; 
                                    out puiDetectedCodePages: SYSUINT; 
                                    var pnDetectedCodePages: SYSUINT; lpSpecialChar: PChar): HResult; stdcall;
    function DetectOutboundCodePageInIStream(dwFlags: LongWord; const pStrIn: IStream; 
                                             var puiPreferredCodePages: SYSUINT; 
                                             nPreferredCodePages: SYSUINT; 
                                             out puiDetectedCodePages: SYSUINT; 
                                             var pnDetectedCodePages: SYSUINT; 
                                             lpSpecialChar: PChar): HResult; stdcall;
  end;

// *********************************************************************//

// クラス CMLangString は、Create および CreateRemote メソッドを使用して

// CoClass CMLangString が公開するデフォルトのインターフェイス IMLangString の

// インスタンスを作成する。このタイプ ライブラリのサーバーによって

// 公開された CoClass オブジェクトに対し、オートメーションを行いたい

// クライアントが用いるために、これらの関数が存在する。

// *********************************************************************//

  CoCMLangString = class
    class function Create: IMLangString;
    class function CreateRemote(const MachineName: string): IMLangString;
  end;


// *********************************************************************//
// OLE サーバー プロキシ クラス宣言
// サーバー オブジェクト: TCMLangString
// ヘルプ文字列: MLangString Class
// デフォルト インターフェイス: IMLangString
// デフォルト インターフェイス ディスパッチ?: No
// イベント インターフェイス: 
// タイプ フラグ        : (2) CanCreate
// *********************************************************************//
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  TCMLangStringProperties= class;
{$ENDIF}
  TCMLangString = class(TOleServer)
  private
    FIntf: IMLangString;
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
    FProps: TCMLangStringProperties;
    function GetServerProperties: TCMLangStringProperties;
{$ENDIF}
    function GetDefaultInterface: IMLangString;
  protected
    procedure InitServerData; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;
    procedure Connect; override;
    procedure ConnectTo(svrIntf: IMLangString);
    procedure Disconnect; override;
    function Sync(fNoAccess: Integer): HResult;
    function GetLength(out plLen: Integer): HResult;
    function SetMLStr(lDestPos: Integer; lDestLen: Integer; const pSrcMLStr: IUnknown; 
                      lSrcPos: Integer; lSrcLen: Integer): HResult;
    function GetMLStr(lSrcPos: Integer; lSrcLen: Integer; const pUnkOuter: IUnknown; 
                      dwClsContext: LongWord; var piid: TGUID; out ppDestMLStr: IUnknown; 
                      out plDestPos: Integer; out plDestLen: Integer): HResult;
    property DefaultInterface: IMLangString read GetDefaultInterface;
  published
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
    property Server: TCMLangStringProperties read GetServerProperties;
{$ENDIF}
  end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
// *********************************************************************//
// OLE サーバー プロパティ プロキシ クラス
// サーバー オブジェクト: TCMLangString
// (このオブジェクトは、このサーバーのプロパティを編集できるようにするため
// IDE のプロパティ インスペクタで使用されます)
// *********************************************************************//
 TCMLangStringProperties = class(TPersistent)
  private
    FServer:    TCMLangString;
    function    GetDefaultInterface: IMLangString;
    constructor Create(AServer: TCMLangString);
  protected
  public
    property DefaultInterface: IMLangString read GetDefaultInterface;
  published
  end;
{$ENDIF}


// *********************************************************************//

// クラス CMLangConvertCharset は、Create および CreateRemote メソッドを使用して

// CoClass CMLangConvertCharset が公開するデフォルトのインターフェイス IMLangConvertCharset の

// インスタンスを作成する。このタイプ ライブラリのサーバーによって

// 公開された CoClass オブジェクトに対し、オートメーションを行いたい

// クライアントが用いるために、これらの関数が存在する。

// *********************************************************************//

  CoCMLangConvertCharset = class
    class function Create: IMLangConvertCharset;
    class function CreateRemote(const MachineName: string): IMLangConvertCharset;
  end;


// *********************************************************************//
// OLE サーバー プロキシ クラス宣言
// サーバー オブジェクト: TCMLangConvertCharset
// ヘルプ文字列: 
// デフォルト インターフェイス: IMLangConvertCharset
// デフォルト インターフェイス ディスパッチ?: No
// イベント インターフェイス: 
// タイプ フラグ        : (2) CanCreate
// *********************************************************************//
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  TCMLangConvertCharsetProperties= class;
{$ENDIF}
  TCMLangConvertCharset = class(TOleServer)
  private
    FIntf: IMLangConvertCharset;
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
    FProps: TCMLangConvertCharsetProperties;
    function GetServerProperties: TCMLangConvertCharsetProperties;
{$ENDIF}
    function GetDefaultInterface: IMLangConvertCharset;
  protected
    procedure InitServerData; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;
    procedure Connect; override;
    procedure ConnectTo(svrIntf: IMLangConvertCharset);
    procedure Disconnect; override;
    function Initialize(uiSrcCodePage: SYSUINT; uiDstCodePage: SYSUINT; dwProperty: LongWord): HResult;
    function GetSourceCodePage(out puiSrcCodePage: SYSUINT): HResult;
    function GetDestinationCodePage(out puiDstCodePage: SYSUINT): HResult;
    function GetProperty(out pdwProperty: LongWord): HResult;
    function DoConversion(var pSrcStr: Byte; var pcSrcSize: SYSUINT; out pDstStr: Byte; 
                          var pcDstSize: SYSUINT): HResult;
    function DoConversionToUnicode(var pSrcStr: Char; var pcSrcSize: SYSUINT;
                                   out pDstStr: Char; var pcDstSize: SYSUINT): HResult;
    function DoConversionFromUnicode(var pSrcStr: Char; var pcSrcSize: SYSUINT;
                                     out pDstStr: Char; var pcDstSize: SYSUINT): HResult;
    property DefaultInterface: IMLangConvertCharset read GetDefaultInterface;
  published
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
    property Server: TCMLangConvertCharsetProperties read GetServerProperties;
{$ENDIF}
  end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
// *********************************************************************//
// OLE サーバー プロパティ プロキシ クラス
// サーバー オブジェクト: TCMLangConvertCharset
// (このオブジェクトは、このサーバーのプロパティを編集できるようにするため
// IDE のプロパティ インスペクタで使用されます)
// *********************************************************************//
 TCMLangConvertCharsetProperties = class(TPersistent)
  private
    FServer:    TCMLangConvertCharset;
    function    GetDefaultInterface: IMLangConvertCharset;
    constructor Create(AServer: TCMLangConvertCharset);
  protected
  public
    property DefaultInterface: IMLangConvertCharset read GetDefaultInterface;
  published
  end;
{$ENDIF}


// *********************************************************************//

// クラス CMultiLanguage は、Create および CreateRemote メソッドを使用して

// CoClass CMultiLanguage が公開するデフォルトのインターフェイス IMultiLanguage の

// インスタンスを作成する。このタイプ ライブラリのサーバーによって

// 公開された CoClass オブジェクトに対し、オートメーションを行いたい

// クライアントが用いるために、これらの関数が存在する。

// *********************************************************************//

  CoCMultiLanguage = class
    class function Create: IMultiLanguage;
    class function CreateRemote(const MachineName: string): IMultiLanguage;
  end;


// *********************************************************************//
// OLE サーバー プロキシ クラス宣言
// サーバー オブジェクト: TCMultiLanguage
// ヘルプ文字列: 
// デフォルト インターフェイス: IMultiLanguage
// デフォルト インターフェイス ディスパッチ?: No
// イベント インターフェイス: 
// タイプ フラグ        : (2) CanCreate
// *********************************************************************//
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  TCMultiLanguageProperties= class;
{$ENDIF}
  TCMultiLanguage = class(TOleServer)
  private
    FIntf: IMultiLanguage;
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
    FProps: TCMultiLanguageProperties;
    function GetServerProperties: TCMultiLanguageProperties;
{$ENDIF}
    function GetDefaultInterface: IMultiLanguage;
  protected
    procedure InitServerData; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;
    procedure Connect; override;
    procedure ConnectTo(svrIntf: IMultiLanguage);
    procedure Disconnect; override;
    function GetNumberOfCodePageInfo(out pcCodePage: SYSUINT): HResult;
    function GetCodePageInfo(uiCodePage: SYSUINT; out pCodePageInfo: tagMIMECPINFO): HResult;
    function GetFamilyCodePage(uiCodePage: SYSUINT; out puiFamilyCodePage: SYSUINT): HResult;
    function EnumCodePages(grfFlags: LongWord; out ppEnumCodePage: IEnumCodePage): HResult;
    function GetCharsetInfo(const Charset: String; out pCharsetInfo: tagMIMECSETINFO): HResult;
    function IsConvertible(dwSrcEncoding: LongWord; dwDstEncoding: LongWord): HResult;
    function ConvertString(var pdwMode: LongWord; dwSrcEncoding: LongWord; dwDstEncoding: LongWord; 
                           var pSrcStr: Byte; var pcSrcSize: SYSUINT; out pDstStr: Byte; 
                           var pcDstSize: SYSUINT): HResult;
    function ConvertStringToUnicode(var pdwMode: LongWord; dwEncoding: LongWord; 
                                    var pSrcStr: Char; var pcSrcSize: SYSUINT;
                                    out pDstStr: Char; var pcDstSize: SYSUINT): HResult;
    function ConvertStringFromUnicode(var pdwMode: LongWord; dwEncoding: LongWord; 
                                      var pSrcStr: Char; var pcSrcSize: SYSUINT;
                                      out pDstStr: Char; var pcDstSize: SYSUINT): HResult;
    function ConvertStringReset: HResult;
    function GetRfc1766FromLcid(locale: LongWord; out pbstrRfc1766: String): HResult;
    function GetLcidFromRfc1766(out plocale: LongWord; const bstrRfc1766: String): HResult;
    function EnumRfc1766(out ppEnumRfc1766: IEnumRfc1766): HResult;
    function GetRfc1766Info(locale: LongWord; out pRfc1766Info: tagRFC1766INFO): HResult;
    function CreateConvertCharset(uiSrcCodePage: SYSUINT; uiDstCodePage: SYSUINT; 
                                  dwProperty: LongWord; 
                                  out ppMLangConvertCharset: IMLangConvertCharset): HResult;
    property DefaultInterface: IMultiLanguage read GetDefaultInterface;
  published
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
    property Server: TCMultiLanguageProperties read GetServerProperties;
{$ENDIF}
  end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
// *********************************************************************//
// OLE サーバー プロパティ プロキシ クラス
// サーバー オブジェクト: TCMultiLanguage
// (このオブジェクトは、このサーバーのプロパティを編集できるようにするため
// IDE のプロパティ インスペクタで使用されます)
// *********************************************************************//
 TCMultiLanguageProperties = class(TPersistent)
  private
    FServer:    TCMultiLanguage;
    function    GetDefaultInterface: IMultiLanguage;
    constructor Create(AServer: TCMultiLanguage);
  protected
  public
    property DefaultInterface: IMultiLanguage read GetDefaultInterface;
  published
  end;
{$ENDIF}


procedure Register;

resourcestring
  dtlServerPage = 'Servers';

  dtlOcxPage = 'ActiveX';

implementation

uses ComObj;

class function CoCMLangString.Create: IMLangString;
begin
  Result := CreateComObject(CLASS_CMLangString) as IMLangString;
end;

class function CoCMLangString.CreateRemote(const MachineName: string): IMLangString;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_CMLangString) as IMLangString;
end;

procedure TCMLangString.InitServerData;
const
  CServerData: TServerData = (
    ClassID:   '{C04D65CF-B70D-11D0-B188-00AA0038C969}';
    IntfIID:   '{C04D65CE-B70D-11D0-B188-00AA0038C969}';
    EventIID:  '';
    LicenseKey: nil;
    Version: 500);
begin
  ServerData := @CServerData;
end;

procedure TCMLangString.Connect;
var
  punk: IUnknown;
begin
  if FIntf = nil then
  begin
    punk := GetServer;
    Fintf:= punk as IMLangString;
  end;
end;

procedure TCMLangString.ConnectTo(svrIntf: IMLangString);
begin
  Disconnect;
  FIntf := svrIntf;
end;

procedure TCMLangString.DisConnect;
begin
  if Fintf <> nil then
  begin
    FIntf := nil;
  end;
end;

function TCMLangString.GetDefaultInterface: IMLangString;
begin
  if FIntf = nil then
    Connect;
  Assert(FIntf <> nil, 'DefaultInterface が NULL です。コンポーネントはサーバーに接続していません。このオペレーションの前に "Connect" または "ConnectTo" を呼び出す必要があります。');
  Result := FIntf;
end;

constructor TCMLangString.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  FProps := TCMLangStringProperties.Create(Self);
{$ENDIF}
end;

destructor TCMLangString.Destroy;
begin
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  FProps.Free;
{$ENDIF}
  inherited Destroy;
end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
function TCMLangString.GetServerProperties: TCMLangStringProperties;
begin
  Result := FProps;
end;
{$ENDIF}

function TCMLangString.Sync(fNoAccess: Integer): HResult;
begin
  Result := DefaultInterface.Sync(fNoAccess);
end;

function TCMLangString.GetLength(out plLen: Integer): HResult;
begin
  Result := DefaultInterface.GetLength(plLen);
end;

function TCMLangString.SetMLStr(lDestPos: Integer; lDestLen: Integer; const pSrcMLStr: IUnknown; 
                                lSrcPos: Integer; lSrcLen: Integer): HResult;
begin
  Result := DefaultInterface.SetMLStr(lDestPos, lDestLen, pSrcMLStr, lSrcPos, lSrcLen);
end;

function TCMLangString.GetMLStr(lSrcPos: Integer; lSrcLen: Integer; const pUnkOuter: IUnknown; 
                                dwClsContext: LongWord; var piid: TGUID; out ppDestMLStr: IUnknown; 
                                out plDestPos: Integer; out plDestLen: Integer): HResult;
begin
  Result := DefaultInterface.GetMLStr(lSrcPos, lSrcLen, pUnkOuter, dwClsContext, piid, ppDestMLStr, 
                                      plDestPos, plDestLen);
end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
constructor TCMLangStringProperties.Create(AServer: TCMLangString);
begin
  inherited Create;
  FServer := AServer;
end;

function TCMLangStringProperties.GetDefaultInterface: IMLangString;
begin
  Result := FServer.DefaultInterface;
end;

{$ENDIF}

class function CoCMLangConvertCharset.Create: IMLangConvertCharset;
begin
  Result := CreateComObject(CLASS_CMLangConvertCharset) as IMLangConvertCharset;
end;

class function CoCMLangConvertCharset.CreateRemote(const MachineName: string): IMLangConvertCharset;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_CMLangConvertCharset) as IMLangConvertCharset;
end;

procedure TCMLangConvertCharset.InitServerData;
const
  CServerData: TServerData = (
    ClassID:   '{D66D6F99-CDAA-11D0-B822-00C04FC9B31F}';
    IntfIID:   '{D66D6F98-CDAA-11D0-B822-00C04FC9B31F}';
    EventIID:  '';
    LicenseKey: nil;
    Version: 500);
begin
  ServerData := @CServerData;
end;

procedure TCMLangConvertCharset.Connect;
var
  punk: IUnknown;
begin
  if FIntf = nil then
  begin
    punk := GetServer;
    Fintf:= punk as IMLangConvertCharset;
  end;
end;

procedure TCMLangConvertCharset.ConnectTo(svrIntf: IMLangConvertCharset);
begin
  Disconnect;
  FIntf := svrIntf;
end;

procedure TCMLangConvertCharset.DisConnect;
begin
  if Fintf <> nil then
  begin
    FIntf := nil;
  end;
end;

function TCMLangConvertCharset.GetDefaultInterface: IMLangConvertCharset;
begin
  if FIntf = nil then
    Connect;
  Assert(FIntf <> nil, 'DefaultInterface が NULL です。コンポーネントはサーバーに接続していません。このオペレーションの前に "Connect" または "ConnectTo" を呼び出す必要があります。');
  Result := FIntf;
end;

constructor TCMLangConvertCharset.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  FProps := TCMLangConvertCharsetProperties.Create(Self);
{$ENDIF}
end;

destructor TCMLangConvertCharset.Destroy;
begin
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  FProps.Free;
{$ENDIF}
  inherited Destroy;
end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
function TCMLangConvertCharset.GetServerProperties: TCMLangConvertCharsetProperties;
begin
  Result := FProps;
end;
{$ENDIF}

function TCMLangConvertCharset.Initialize(uiSrcCodePage: SYSUINT; uiDstCodePage: SYSUINT; 
                                          dwProperty: LongWord): HResult;
begin
  Result := DefaultInterface.Initialize(uiSrcCodePage, uiDstCodePage, dwProperty);
end;

function TCMLangConvertCharset.GetSourceCodePage(out puiSrcCodePage: SYSUINT): HResult;
begin
  Result := DefaultInterface.GetSourceCodePage(puiSrcCodePage);
end;

function TCMLangConvertCharset.GetDestinationCodePage(out puiDstCodePage: SYSUINT): HResult;
begin
  Result := DefaultInterface.GetDestinationCodePage(puiDstCodePage);
end;

function TCMLangConvertCharset.GetProperty(out pdwProperty: LongWord): HResult;
begin
  Result := DefaultInterface.GetProperty(pdwProperty);
end;

function TCMLangConvertCharset.DoConversion(var pSrcStr: Byte; var pcSrcSize: SYSUINT; 
                                            out pDstStr: Byte; var pcDstSize: SYSUINT): HResult;
begin
  Result := DefaultInterface.DoConversion(pSrcStr, pcSrcSize, pDstStr, pcDstSize);
end;

function TCMLangConvertCharset.DoConversionToUnicode(var pSrcStr: Char; var pcSrcSize: SYSUINT;
                                                     out pDstStr: Char; var pcDstSize: SYSUINT): HResult;
begin
  Result := DefaultInterface.DoConversionToUnicode(pSrcStr, pcSrcSize, pDstStr, pcDstSize);
end;

function TCMLangConvertCharset.DoConversionFromUnicode(var pSrcStr: Char; var pcSrcSize: SYSUINT;
                                                       out pDstStr: Char; var pcDstSize: SYSUINT): HResult;
begin
  Result := DefaultInterface.DoConversionFromUnicode(pSrcStr, pcSrcSize, pDstStr, pcDstSize);
end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
constructor TCMLangConvertCharsetProperties.Create(AServer: TCMLangConvertCharset);
begin
  inherited Create;
  FServer := AServer;
end;

function TCMLangConvertCharsetProperties.GetDefaultInterface: IMLangConvertCharset;
begin
  Result := FServer.DefaultInterface;
end;

{$ENDIF}

class function CoCMultiLanguage.Create: IMultiLanguage;
begin
  Result := CreateComObject(CLASS_CMultiLanguage) as IMultiLanguage;
end;

class function CoCMultiLanguage.CreateRemote(const MachineName: string): IMultiLanguage;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_CMultiLanguage) as IMultiLanguage;
end;

procedure TCMultiLanguage.InitServerData;
const
  CServerData: TServerData = (
    ClassID:   '{275C23E2-3747-11D0-9FEA-00AA003F8646}';
    IntfIID:   '{275C23E1-3747-11D0-9FEA-00AA003F8646}';
    EventIID:  '';
    LicenseKey: nil;
    Version: 500);
begin
  ServerData := @CServerData;
end;

procedure TCMultiLanguage.Connect;
var
  punk: IUnknown;
begin
  if FIntf = nil then
  begin
    punk := GetServer;
    Fintf:= punk as IMultiLanguage;
  end;
end;

procedure TCMultiLanguage.ConnectTo(svrIntf: IMultiLanguage);
begin
  Disconnect;
  FIntf := svrIntf;
end;

procedure TCMultiLanguage.DisConnect;
begin
  if Fintf <> nil then
  begin
    FIntf := nil;
  end;
end;

function TCMultiLanguage.GetDefaultInterface: IMultiLanguage;
begin
  if FIntf = nil then
    Connect;
  Assert(FIntf <> nil, 'DefaultInterface が NULL です。コンポーネントはサーバーに接続していません。このオペレーションの前に "Connect" または "ConnectTo" を呼び出す必要があります。');
  Result := FIntf;
end;

constructor TCMultiLanguage.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  FProps := TCMultiLanguageProperties.Create(Self);
{$ENDIF}
end;

destructor TCMultiLanguage.Destroy;
begin
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  FProps.Free;
{$ENDIF}
  inherited Destroy;
end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
function TCMultiLanguage.GetServerProperties: TCMultiLanguageProperties;
begin
  Result := FProps;
end;
{$ENDIF}

function TCMultiLanguage.GetNumberOfCodePageInfo(out pcCodePage: SYSUINT): HResult;
begin
  Result := DefaultInterface.GetNumberOfCodePageInfo(pcCodePage);
end;

function TCMultiLanguage.GetCodePageInfo(uiCodePage: SYSUINT; out pCodePageInfo: tagMIMECPINFO): HResult;
begin
  Result := DefaultInterface.GetCodePageInfo(uiCodePage, pCodePageInfo);
end;

function TCMultiLanguage.GetFamilyCodePage(uiCodePage: SYSUINT; out puiFamilyCodePage: SYSUINT): HResult;
begin
  Result := DefaultInterface.GetFamilyCodePage(uiCodePage, puiFamilyCodePage);
end;

function TCMultiLanguage.EnumCodePages(grfFlags: LongWord; out ppEnumCodePage: IEnumCodePage): HResult;
begin
  Result := DefaultInterface.EnumCodePages(grfFlags, ppEnumCodePage);
end;

function TCMultiLanguage.GetCharsetInfo(const Charset: String; out pCharsetInfo: tagMIMECSETINFO): HResult;
begin
  Result := DefaultInterface.GetCharsetInfo(Charset, pCharsetInfo);
end;

function TCMultiLanguage.IsConvertible(dwSrcEncoding: LongWord; dwDstEncoding: LongWord): HResult;
begin
  Result := DefaultInterface.IsConvertible(dwSrcEncoding, dwDstEncoding);
end;

function TCMultiLanguage.ConvertString(var pdwMode: LongWord; dwSrcEncoding: LongWord; 
                                       dwDstEncoding: LongWord; var pSrcStr: Byte; 
                                       var pcSrcSize: SYSUINT; out pDstStr: Byte; 
                                       var pcDstSize: SYSUINT): HResult;
begin
  Result := DefaultInterface.ConvertString(pdwMode, dwSrcEncoding, dwDstEncoding, pSrcStr, 
                                           pcSrcSize, pDstStr, pcDstSize);
end;

function TCMultiLanguage.ConvertStringToUnicode(var pdwMode: LongWord; dwEncoding: LongWord;
                                                var pSrcStr: Char; var pcSrcSize: SYSUINT;
                                                out pDstStr: Char; var pcDstSize: SYSUINT): HResult;
begin
  Result := DefaultInterface.ConvertStringToUnicode(pdwMode, dwEncoding, pSrcStr, pcSrcSize, 
                                                    pDstStr, pcDstSize);
end;

function TCMultiLanguage.ConvertStringFromUnicode(var pdwMode: LongWord; dwEncoding: LongWord; 
                                                  var pSrcStr: Char; var pcSrcSize: SYSUINT;
                                                  out pDstStr: Char; var pcDstSize: SYSUINT): HResult;
begin
  Result := DefaultInterface.ConvertStringFromUnicode(pdwMode, dwEncoding, pSrcStr, pcSrcSize, 
                                                      pDstStr, pcDstSize);
end;

function TCMultiLanguage.ConvertStringReset: HResult;
begin
  Result := DefaultInterface.ConvertStringReset;
end;

function TCMultiLanguage.GetRfc1766FromLcid(locale: LongWord; out pbstrRfc1766: String): HResult;
begin
  Result := DefaultInterface.GetRfc1766FromLcid(locale, pbstrRfc1766);
end;

function TCMultiLanguage.GetLcidFromRfc1766(out plocale: LongWord; const bstrRfc1766: String): HResult;
begin
  Result := DefaultInterface.GetLcidFromRfc1766(plocale, bstrRfc1766);
end;

function TCMultiLanguage.EnumRfc1766(out ppEnumRfc1766: IEnumRfc1766): HResult;
begin
  Result := DefaultInterface.EnumRfc1766(ppEnumRfc1766);
end;

function TCMultiLanguage.GetRfc1766Info(locale: LongWord; out pRfc1766Info: tagRFC1766INFO): HResult;
begin
  Result := DefaultInterface.GetRfc1766Info(locale, pRfc1766Info);
end;

function TCMultiLanguage.CreateConvertCharset(uiSrcCodePage: SYSUINT; uiDstCodePage: SYSUINT; 
                                              dwProperty: LongWord; 
                                              out ppMLangConvertCharset: IMLangConvertCharset): HResult;
begin
  Result := DefaultInterface.CreateConvertCharset(uiSrcCodePage, uiDstCodePage, dwProperty, 
                                                  ppMLangConvertCharset);
end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
constructor TCMultiLanguageProperties.Create(AServer: TCMultiLanguage);
begin
  inherited Create;
  FServer := AServer;
end;

function TCMultiLanguageProperties.GetDefaultInterface: IMultiLanguage;
begin
  Result := FServer.DefaultInterface;
end;

{$ENDIF}

procedure Register;
begin
  RegisterComponents(dtlServerPage, [TCMLangString, TCMLangConvertCharset, TCMultiLanguage]);
end;

end.
